package com.dhcc.finance.main.domain;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class CwBdAccassExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    public CwBdAccassExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andPkAccassIsNull() {
            addCriterion("PK_ACCASS is null");
            return (Criteria) this;
        }

        public Criteria andPkAccassIsNotNull() {
            addCriterion("PK_ACCASS is not null");
            return (Criteria) this;
        }

        public Criteria andPkAccassEqualTo(String value) {
            addCriterion("PK_ACCASS =", value, "pkAccass");
            return (Criteria) this;
        }

        public Criteria andPkAccassNotEqualTo(String value) {
            addCriterion("PK_ACCASS <>", value, "pkAccass");
            return (Criteria) this;
        }

        public Criteria andPkAccassGreaterThan(String value) {
            addCriterion("PK_ACCASS >", value, "pkAccass");
            return (Criteria) this;
        }

        public Criteria andPkAccassGreaterThanOrEqualTo(String value) {
            addCriterion("PK_ACCASS >=", value, "pkAccass");
            return (Criteria) this;
        }

        public Criteria andPkAccassLessThan(String value) {
            addCriterion("PK_ACCASS <", value, "pkAccass");
            return (Criteria) this;
        }

        public Criteria andPkAccassLessThanOrEqualTo(String value) {
            addCriterion("PK_ACCASS <=", value, "pkAccass");
            return (Criteria) this;
        }

        public Criteria andPkAccassLike(String value) {
            addCriterion("PK_ACCASS like", value, "pkAccass");
            return (Criteria) this;
        }

        public Criteria andPkAccassNotLike(String value) {
            addCriterion("PK_ACCASS not like", value, "pkAccass");
            return (Criteria) this;
        }

        public Criteria andPkAccassIn(List<String> values) {
            addCriterion("PK_ACCASS in", values, "pkAccass");
            return (Criteria) this;
        }

        public Criteria andPkAccassNotIn(List<String> values) {
            addCriterion("PK_ACCASS not in", values, "pkAccass");
            return (Criteria) this;
        }

        public Criteria andPkAccassBetween(String value1, String value2) {
            addCriterion("PK_ACCASS between", value1, value2, "pkAccass");
            return (Criteria) this;
        }

        public Criteria andPkAccassNotBetween(String value1, String value2) {
            addCriterion("PK_ACCASS not between", value1, value2, "pkAccass");
            return (Criteria) this;
        }

        public Criteria andPkSubjschemeIsNull() {
            addCriterion("PK_SUBJSCHEME is null");
            return (Criteria) this;
        }

        public Criteria andPkSubjschemeIsNotNull() {
            addCriterion("PK_SUBJSCHEME is not null");
            return (Criteria) this;
        }

        public Criteria andPkSubjschemeEqualTo(String value) {
            addCriterion("PK_SUBJSCHEME =", value, "pkSubjscheme");
            return (Criteria) this;
        }

        public Criteria andPkSubjschemeNotEqualTo(String value) {
            addCriterion("PK_SUBJSCHEME <>", value, "pkSubjscheme");
            return (Criteria) this;
        }

        public Criteria andPkSubjschemeGreaterThan(String value) {
            addCriterion("PK_SUBJSCHEME >", value, "pkSubjscheme");
            return (Criteria) this;
        }

        public Criteria andPkSubjschemeGreaterThanOrEqualTo(String value) {
            addCriterion("PK_SUBJSCHEME >=", value, "pkSubjscheme");
            return (Criteria) this;
        }

        public Criteria andPkSubjschemeLessThan(String value) {
            addCriterion("PK_SUBJSCHEME <", value, "pkSubjscheme");
            return (Criteria) this;
        }

        public Criteria andPkSubjschemeLessThanOrEqualTo(String value) {
            addCriterion("PK_SUBJSCHEME <=", value, "pkSubjscheme");
            return (Criteria) this;
        }

        public Criteria andPkSubjschemeLike(String value) {
            addCriterion("PK_SUBJSCHEME like", value, "pkSubjscheme");
            return (Criteria) this;
        }

        public Criteria andPkSubjschemeNotLike(String value) {
            addCriterion("PK_SUBJSCHEME not like", value, "pkSubjscheme");
            return (Criteria) this;
        }

        public Criteria andPkSubjschemeIn(List<String> values) {
            addCriterion("PK_SUBJSCHEME in", values, "pkSubjscheme");
            return (Criteria) this;
        }

        public Criteria andPkSubjschemeNotIn(List<String> values) {
            addCriterion("PK_SUBJSCHEME not in", values, "pkSubjscheme");
            return (Criteria) this;
        }

        public Criteria andPkSubjschemeBetween(String value1, String value2) {
            addCriterion("PK_SUBJSCHEME between", value1, value2, "pkSubjscheme");
            return (Criteria) this;
        }

        public Criteria andPkSubjschemeNotBetween(String value1, String value2) {
            addCriterion("PK_SUBJSCHEME not between", value1, value2, "pkSubjscheme");
            return (Criteria) this;
        }

        public Criteria andPkAccsubjIsNull() {
            addCriterion("PK_ACCSUBJ is null");
            return (Criteria) this;
        }

        public Criteria andPkAccsubjIsNotNull() {
            addCriterion("PK_ACCSUBJ is not null");
            return (Criteria) this;
        }

        public Criteria andPkAccsubjEqualTo(String value) {
            addCriterion("PK_ACCSUBJ =", value, "pkAccsubj");
            return (Criteria) this;
        }

        public Criteria andPkAccsubjNotEqualTo(String value) {
            addCriterion("PK_ACCSUBJ <>", value, "pkAccsubj");
            return (Criteria) this;
        }

        public Criteria andPkAccsubjGreaterThan(String value) {
            addCriterion("PK_ACCSUBJ >", value, "pkAccsubj");
            return (Criteria) this;
        }

        public Criteria andPkAccsubjGreaterThanOrEqualTo(String value) {
            addCriterion("PK_ACCSUBJ >=", value, "pkAccsubj");
            return (Criteria) this;
        }

        public Criteria andPkAccsubjLessThan(String value) {
            addCriterion("PK_ACCSUBJ <", value, "pkAccsubj");
            return (Criteria) this;
        }

        public Criteria andPkAccsubjLessThanOrEqualTo(String value) {
            addCriterion("PK_ACCSUBJ <=", value, "pkAccsubj");
            return (Criteria) this;
        }

        public Criteria andPkAccsubjLike(String value) {
            addCriterion("PK_ACCSUBJ like", value, "pkAccsubj");
            return (Criteria) this;
        }

        public Criteria andPkAccsubjNotLike(String value) {
            addCriterion("PK_ACCSUBJ not like", value, "pkAccsubj");
            return (Criteria) this;
        }

        public Criteria andPkAccsubjIn(List<String> values) {
            addCriterion("PK_ACCSUBJ in", values, "pkAccsubj");
            return (Criteria) this;
        }

        public Criteria andPkAccsubjNotIn(List<String> values) {
            addCriterion("PK_ACCSUBJ not in", values, "pkAccsubj");
            return (Criteria) this;
        }

        public Criteria andPkAccsubjBetween(String value1, String value2) {
            addCriterion("PK_ACCSUBJ between", value1, value2, "pkAccsubj");
            return (Criteria) this;
        }

        public Criteria andPkAccsubjNotBetween(String value1, String value2) {
            addCriterion("PK_ACCSUBJ not between", value1, value2, "pkAccsubj");
            return (Criteria) this;
        }

        public Criteria andAssorderIsNull() {
            addCriterion("ASSORDER is null");
            return (Criteria) this;
        }

        public Criteria andAssorderIsNotNull() {
            addCriterion("ASSORDER is not null");
            return (Criteria) this;
        }

        public Criteria andAssorderEqualTo(Integer value) {
            addCriterion("ASSORDER =", value, "assorder");
            return (Criteria) this;
        }

        public Criteria andAssorderNotEqualTo(Integer value) {
            addCriterion("ASSORDER <>", value, "assorder");
            return (Criteria) this;
        }

        public Criteria andAssorderGreaterThan(Integer value) {
            addCriterion("ASSORDER >", value, "assorder");
            return (Criteria) this;
        }

        public Criteria andAssorderGreaterThanOrEqualTo(Integer value) {
            addCriterion("ASSORDER >=", value, "assorder");
            return (Criteria) this;
        }

        public Criteria andAssorderLessThan(Integer value) {
            addCriterion("ASSORDER <", value, "assorder");
            return (Criteria) this;
        }

        public Criteria andAssorderLessThanOrEqualTo(Integer value) {
            addCriterion("ASSORDER <=", value, "assorder");
            return (Criteria) this;
        }

        public Criteria andAssorderIn(List<Integer> values) {
            addCriterion("ASSORDER in", values, "assorder");
            return (Criteria) this;
        }

        public Criteria andAssorderNotIn(List<Integer> values) {
            addCriterion("ASSORDER not in", values, "assorder");
            return (Criteria) this;
        }

        public Criteria andAssorderBetween(Integer value1, Integer value2) {
            addCriterion("ASSORDER between", value1, value2, "assorder");
            return (Criteria) this;
        }

        public Criteria andAssorderNotBetween(Integer value1, Integer value2) {
            addCriterion("ASSORDER not between", value1, value2, "assorder");
            return (Criteria) this;
        }

        public Criteria andPkAccassitemIsNull() {
            addCriterion("PK_ACCASSITEM is null");
            return (Criteria) this;
        }

        public Criteria andPkAccassitemIsNotNull() {
            addCriterion("PK_ACCASSITEM is not null");
            return (Criteria) this;
        }

        public Criteria andPkAccassitemEqualTo(String value) {
            addCriterion("PK_ACCASSITEM =", value, "pkAccassitem");
            return (Criteria) this;
        }

        public Criteria andPkAccassitemNotEqualTo(String value) {
            addCriterion("PK_ACCASSITEM <>", value, "pkAccassitem");
            return (Criteria) this;
        }

        public Criteria andPkAccassitemGreaterThan(String value) {
            addCriterion("PK_ACCASSITEM >", value, "pkAccassitem");
            return (Criteria) this;
        }

        public Criteria andPkAccassitemGreaterThanOrEqualTo(String value) {
            addCriterion("PK_ACCASSITEM >=", value, "pkAccassitem");
            return (Criteria) this;
        }

        public Criteria andPkAccassitemLessThan(String value) {
            addCriterion("PK_ACCASSITEM <", value, "pkAccassitem");
            return (Criteria) this;
        }

        public Criteria andPkAccassitemLessThanOrEqualTo(String value) {
            addCriterion("PK_ACCASSITEM <=", value, "pkAccassitem");
            return (Criteria) this;
        }

        public Criteria andPkAccassitemLike(String value) {
            addCriterion("PK_ACCASSITEM like", value, "pkAccassitem");
            return (Criteria) this;
        }

        public Criteria andPkAccassitemNotLike(String value) {
            addCriterion("PK_ACCASSITEM not like", value, "pkAccassitem");
            return (Criteria) this;
        }

        public Criteria andPkAccassitemIn(List<String> values) {
            addCriterion("PK_ACCASSITEM in", values, "pkAccassitem");
            return (Criteria) this;
        }

        public Criteria andPkAccassitemNotIn(List<String> values) {
            addCriterion("PK_ACCASSITEM not in", values, "pkAccassitem");
            return (Criteria) this;
        }

        public Criteria andPkAccassitemBetween(String value1, String value2) {
            addCriterion("PK_ACCASSITEM between", value1, value2, "pkAccassitem");
            return (Criteria) this;
        }

        public Criteria andPkAccassitemNotBetween(String value1, String value2) {
            addCriterion("PK_ACCASSITEM not between", value1, value2, "pkAccassitem");
            return (Criteria) this;
        }

        public Criteria andIsmustIsNull() {
            addCriterion("ISMUST is null");
            return (Criteria) this;
        }

        public Criteria andIsmustIsNotNull() {
            addCriterion("ISMUST is not null");
            return (Criteria) this;
        }

        public Criteria andIsmustEqualTo(String value) {
            addCriterion("ISMUST =", value, "ismust");
            return (Criteria) this;
        }

        public Criteria andIsmustNotEqualTo(String value) {
            addCriterion("ISMUST <>", value, "ismust");
            return (Criteria) this;
        }

        public Criteria andIsmustGreaterThan(String value) {
            addCriterion("ISMUST >", value, "ismust");
            return (Criteria) this;
        }

        public Criteria andIsmustGreaterThanOrEqualTo(String value) {
            addCriterion("ISMUST >=", value, "ismust");
            return (Criteria) this;
        }

        public Criteria andIsmustLessThan(String value) {
            addCriterion("ISMUST <", value, "ismust");
            return (Criteria) this;
        }

        public Criteria andIsmustLessThanOrEqualTo(String value) {
            addCriterion("ISMUST <=", value, "ismust");
            return (Criteria) this;
        }

        public Criteria andIsmustLike(String value) {
            addCriterion("ISMUST like", value, "ismust");
            return (Criteria) this;
        }

        public Criteria andIsmustNotLike(String value) {
            addCriterion("ISMUST not like", value, "ismust");
            return (Criteria) this;
        }

        public Criteria andIsmustIn(List<String> values) {
            addCriterion("ISMUST in", values, "ismust");
            return (Criteria) this;
        }

        public Criteria andIsmustNotIn(List<String> values) {
            addCriterion("ISMUST not in", values, "ismust");
            return (Criteria) this;
        }

        public Criteria andIsmustBetween(String value1, String value2) {
            addCriterion("ISMUST between", value1, value2, "ismust");
            return (Criteria) this;
        }

        public Criteria andIsmustNotBetween(String value1, String value2) {
            addCriterion("ISMUST not between", value1, value2, "ismust");
            return (Criteria) this;
        }

        public Criteria andUseStateIsNull() {
            addCriterion("USE_STATE is null");
            return (Criteria) this;
        }

        public Criteria andUseStateIsNotNull() {
            addCriterion("USE_STATE is not null");
            return (Criteria) this;
        }

        public Criteria andUseStateEqualTo(String value) {
            addCriterion("USE_STATE =", value, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateNotEqualTo(String value) {
            addCriterion("USE_STATE <>", value, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateGreaterThan(String value) {
            addCriterion("USE_STATE >", value, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateGreaterThanOrEqualTo(String value) {
            addCriterion("USE_STATE >=", value, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateLessThan(String value) {
            addCriterion("USE_STATE <", value, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateLessThanOrEqualTo(String value) {
            addCriterion("USE_STATE <=", value, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateLike(String value) {
            addCriterion("USE_STATE like", value, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateNotLike(String value) {
            addCriterion("USE_STATE not like", value, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateIn(List<String> values) {
            addCriterion("USE_STATE in", values, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateNotIn(List<String> values) {
            addCriterion("USE_STATE not in", values, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateBetween(String value1, String value2) {
            addCriterion("USE_STATE between", value1, value2, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateNotBetween(String value1, String value2) {
            addCriterion("USE_STATE not between", value1, value2, "useState");
            return (Criteria) this;
        }

        public Criteria andCreateUserIsNull() {
            addCriterion("CREATE_USER is null");
            return (Criteria) this;
        }

        public Criteria andCreateUserIsNotNull() {
            addCriterion("CREATE_USER is not null");
            return (Criteria) this;
        }

        public Criteria andCreateUserEqualTo(String value) {
            addCriterion("CREATE_USER =", value, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserNotEqualTo(String value) {
            addCriterion("CREATE_USER <>", value, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserGreaterThan(String value) {
            addCriterion("CREATE_USER >", value, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserGreaterThanOrEqualTo(String value) {
            addCriterion("CREATE_USER >=", value, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserLessThan(String value) {
            addCriterion("CREATE_USER <", value, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserLessThanOrEqualTo(String value) {
            addCriterion("CREATE_USER <=", value, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserLike(String value) {
            addCriterion("CREATE_USER like", value, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserNotLike(String value) {
            addCriterion("CREATE_USER not like", value, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserIn(List<String> values) {
            addCriterion("CREATE_USER in", values, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserNotIn(List<String> values) {
            addCriterion("CREATE_USER not in", values, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserBetween(String value1, String value2) {
            addCriterion("CREATE_USER between", value1, value2, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserNotBetween(String value1, String value2) {
            addCriterion("CREATE_USER not between", value1, value2, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNull() {
            addCriterion("CREATE_TIME is null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNotNull() {
            addCriterion("CREATE_TIME is not null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeEqualTo(Date value) {
            addCriterion("CREATE_TIME =", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotEqualTo(Date value) {
            addCriterion("CREATE_TIME <>", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThan(Date value) {
            addCriterion("CREATE_TIME >", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("CREATE_TIME >=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThan(Date value) {
            addCriterion("CREATE_TIME <", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThanOrEqualTo(Date value) {
            addCriterion("CREATE_TIME <=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIn(List<Date> values) {
            addCriterion("CREATE_TIME in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotIn(List<Date> values) {
            addCriterion("CREATE_TIME not in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeBetween(Date value1, Date value2) {
            addCriterion("CREATE_TIME between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotBetween(Date value1, Date value2) {
            addCriterion("CREATE_TIME not between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIsNull() {
            addCriterion("UPDATE_USER is null");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIsNotNull() {
            addCriterion("UPDATE_USER is not null");
            return (Criteria) this;
        }

        public Criteria andUpdateUserEqualTo(String value) {
            addCriterion("UPDATE_USER =", value, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserNotEqualTo(String value) {
            addCriterion("UPDATE_USER <>", value, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserGreaterThan(String value) {
            addCriterion("UPDATE_USER >", value, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserGreaterThanOrEqualTo(String value) {
            addCriterion("UPDATE_USER >=", value, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserLessThan(String value) {
            addCriterion("UPDATE_USER <", value, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserLessThanOrEqualTo(String value) {
            addCriterion("UPDATE_USER <=", value, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserLike(String value) {
            addCriterion("UPDATE_USER like", value, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserNotLike(String value) {
            addCriterion("UPDATE_USER not like", value, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIn(List<String> values) {
            addCriterion("UPDATE_USER in", values, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserNotIn(List<String> values) {
            addCriterion("UPDATE_USER not in", values, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserBetween(String value1, String value2) {
            addCriterion("UPDATE_USER between", value1, value2, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserNotBetween(String value1, String value2) {
            addCriterion("UPDATE_USER not between", value1, value2, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNull() {
            addCriterion("UPDATE_TIME is null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNotNull() {
            addCriterion("UPDATE_TIME is not null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeEqualTo(Date value) {
            addCriterion("UPDATE_TIME =", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotEqualTo(Date value) {
            addCriterion("UPDATE_TIME <>", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThan(Date value) {
            addCriterion("UPDATE_TIME >", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("UPDATE_TIME >=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThan(Date value) {
            addCriterion("UPDATE_TIME <", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThanOrEqualTo(Date value) {
            addCriterion("UPDATE_TIME <=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIn(List<Date> values) {
            addCriterion("UPDATE_TIME in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotIn(List<Date> values) {
            addCriterion("UPDATE_TIME not in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeBetween(Date value1, Date value2) {
            addCriterion("UPDATE_TIME between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotBetween(Date value1, Date value2) {
            addCriterion("UPDATE_TIME not between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andRemarkIsNull() {
            addCriterion("REMARK is null");
            return (Criteria) this;
        }

        public Criteria andRemarkIsNotNull() {
            addCriterion("REMARK is not null");
            return (Criteria) this;
        }

        public Criteria andRemarkEqualTo(String value) {
            addCriterion("REMARK =", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkNotEqualTo(String value) {
            addCriterion("REMARK <>", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkGreaterThan(String value) {
            addCriterion("REMARK >", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkGreaterThanOrEqualTo(String value) {
            addCriterion("REMARK >=", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkLessThan(String value) {
            addCriterion("REMARK <", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkLessThanOrEqualTo(String value) {
            addCriterion("REMARK <=", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkLike(String value) {
            addCriterion("REMARK like", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkNotLike(String value) {
            addCriterion("REMARK not like", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkIn(List<String> values) {
            addCriterion("REMARK in", values, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkNotIn(List<String> values) {
            addCriterion("REMARK not in", values, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkBetween(String value1, String value2) {
            addCriterion("REMARK between", value1, value2, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkNotBetween(String value1, String value2) {
            addCriterion("REMARK not between", value1, value2, "remark");
            return (Criteria) this;
        }
    }

    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}